﻿/**
環境変数。

History:
	1.021:
		[S] module変更。

	1.020:
		[S] package変更。
*/
module etc.negui.environ.variable;

debug import std.stdio: wl = writefln;
debug(variable) void main() {}

import std.array;

import win32.windows;

import etc.negui.system.base;
import etc.negui.environ.environ;

///
class EnvVarException: EnvironException {
	mixin MixInNeGuiException;
}

/**
%**%の展開。
*/
Text EnvToPlain(in Text EnvText)
in {
	assert(EnvText.length);
}
body {
	auto pEnvText=EnvText.ptr;
	DWORD Length=ExpandEnvironmentStrings(pEnvText, null, 0);

	auto text=new wchar[Length];
	ExpandEnvironmentStrings(pEnvText, text.ptr, Length);

	return Text(text[0..Length-1]);
}
/***/
Text toPlain(in Text t) {
	if(t.indexOf('%', Text.CASE_SENSITIVE.YES, Text.START.HEAD) == -1) {
		return cast(Text)t;
	}
	return EnvToPlain(t);
}
debug(env) {
	import etc.negui.environ.name;
	unittest {
		Text t1="ComSpec";
		Text t2=t1;
		assert(toPlain(t1) == t2);

		assert(EnvToPlain(Text(`%USERNAME%`)) == UserName);
	}
}

