﻿/**
プロセス。

Bugs:
	よく理解もせずに組むとこうなるよ、っていう典型。
	ワケ分からん。

History:
	1.100:
		新規作成。
*/
module etc.negui.process.process;

debug import std.stdio: wl = writefln;
debug(process) void main() {}

import std.contracts;

import win32.windows;
import win32.shlobj;

import etc.negui.system.base;
import etc.negui.environ.security;
import etc.negui.negui;
import etc.negui.process.pipe;
import etc.negui.window.window;
import etc.negui.input.keyboard.keyboard;
import etc.negui.draw.icon;
import etc.negui.environ.monitor;
import etc.negui.process.console;

enum {
	CREATE_FORCEDOS = 0x00002000,
}

///
class ProcessException: NeGuiException {
	mixin MixInNeGuiException;
}

/***/
struct PROCESSINFORMATION {
	PROCESS_INFORMATION ProcessInformation;
	mixin(SMixInStructHiddenOriginal!(PROCESS_INFORMATION)(q{ProcessInformation}));

	/***/
	@property const Process process() {
		return new Process(ProcessInformation.hProcess, null, false);
	}
	/// ditto
	@property void process(in Process process) {
		ProcessInformation.hProcess = process ? process(): null;
	}

	mixin(SMixInStructGetSet!(HANDLE)("thread", q{ProcessInformation.hThread}));

	mixin(SMixInStructGetSet!(DWORD)("processID", q{ProcessInformation.dwProcessId}));
	mixin(SMixInStructGetSet!(DWORD)("threadID", q{ProcessInformation.dwThreadId}));
}
/***/
struct STARTUPINFORMATION {
	STARTUPINFO StartupInformation;
	mixin(SMixInStructHiddenOriginal!(STARTUPINFO)(q{StartupInformation}));

	///
	void initialize() {
		StartupInformation.cb = StartupInformation.sizeof;
		StartupInformation.lpReserved = null;
		StartupInformation.cbReserved2 = 0;
		StartupInformation.lpReserved2 = null;
	}

	mixin(SMixInStructGetSet!(Text, true)("desktop", q{StartupInformation.lpDesktop}));
	mixin(SMixInStructGetSet!(Text, true)("title", q{StartupInformation.lpTitle}));

	/***/
	@property const ref POINT position() {
		auto Position=new POINT;

		Position.x = StartupInformation.dwX;
		Position.y = StartupInformation.dwY;

		return *Position;
	}
	/// ditto
	@property void position(const ref POINT Position) {
		StartupInformation.dwX = Position.x;
		StartupInformation.dwY = Position.y;
	}

	/***/
	@property const ref SIZE size() {
		auto Size=new SIZE;

		Size.cx = StartupInformation.dwXSize;
		Size.cy = StartupInformation.dwYSize;

		return *Size;
	}
	/// ditto
	@property void size(const ref SIZE Size) {
		StartupInformation.dwXSize = Size.cx;
		StartupInformation.dwYSize = Size.cy;
	}

	/***/
	@property const ref SIZE sizeCharacter() {
		auto Size=new SIZE;

		Size.cx = StartupInformation.dwXCountChars;
		Size.cy = StartupInformation.dwYCountChars;

		return *Size;
	}
	/// ditto
	@property void sizeCharacter(const ref SIZE Size) {
		StartupInformation.dwXCountChars = Size.cx;
		StartupInformation.dwYCountChars = Size.cy;
	}

	/+
	/**
	列挙体にする意味無い
	*/
	enum FILLATTRIBUTE {
		FOREGROUND_BLUE      = FOREGROUND_BLUE      , /// 文字色に青を含ませます。
		FOREGROUND_GREEN     = FOREGROUND_GREEN     , /// 文字色に緑を含ませます。
		FOREGROUND_RED       = FOREGROUND_RED       , /// 文字色に赤を含ませます。
		FOREGROUND_INTENSITY = FOREGROUND_INTENSITY , /// 文字色を強調します。

		BACKGROUND_BLUE      = BACKGROUND_BLUE      , /// 背景色に青を含ませます。
		BACKGROUND_GREEN     = BACKGROUND_GREEN     , /// 背景色に緑を含ませます。
		BACKGROUND_RED       = BACKGROUND_RED       , /// 背景色に赤を含ませます。
		BACKGROUND_INTENSITY = BACKGROUND_INTENSITY , /// 背景色を強調します。
	}
	+/
	mixin(SMixInStructGetSet!(FILLATTRIBUTE)("fillAttribute", q{StartupInformation.dwFillAttribute}));

	/***/
	enum FLAG {
		USESHOWWINDOW    = STARTF_USESHOWWINDOW    , /// wShowWindow メンバを有効にします。
		USESIZE          = STARTF_USESIZE          , /// dwXSize、dwYSize メンバを有効にします。
		USEPOSITION      = STARTF_USEPOSITION      , /// dwX、dwY メンバを有効にします。
		USECOUNTCHARS    = STARTF_USECOUNTCHARS    , /// dwXCountChars、dwYCountChars メンバを有効にします。
		USEFILLATTRIBUTE = STARTF_USEFILLATTRIBUTE , /// dwFillAttribute を有効にします。
		USESTDHANDLES    = STARTF_USESTDHANDLES    , /// hStdInput、hStdOutput、hStdError メンバを有効にします。
		RUNFULLSCREEN    = STARTF_RUNFULLSCREEN    , /// 作成するプロセスがコントロール アプリケーションのとき、コンソール ウィンドウをフルスクリーンで表示します（WindowsNT系OSのみ）。
		FORCEONFEEDBACK  = STARTF_FORCEONFEEDBACK  , /// アプリケーション起動時に砂時計カーソルを利用します。
		FORCEOFFFEEDBACK = STARTF_FORCEOFFFEEDBACK , /// アプリケーション起動時にカーソル変更を行いません。
	}
	mixin(SMixInStructGetSet!(FLAG)("flags", q{StartupInformation.dwFlags}));

	mixin(SMixInStructGetSet!(SHOW)("show", q{StartupInformation.wShowWindow}));

	mixin(SMixInStructGetSet!(HANDLE)("stdInput",  q{StartupInformation.hStdInput}));
	mixin(SMixInStructGetSet!(HANDLE)("stdOutput", q{StartupInformation.hStdOutput}));
	mixin(SMixInStructGetSet!(HANDLE)("stdError",  q{StartupInformation.hStdError}));
}

/***/
class Process: HandleRaii {
	//protected alias Handle hProcess;
	//mixin MixInKillResource!("プロセス", hProcess, CloseHandle, 0);
	///
	override protected void Kill() {
		if(Information) {
			Exception e;
			if(Information.hProcess) {
				e = collectException(enforce(CloseHandle(Information.hProcess), new ProcessException(ERR.toText)));
			}
			if(Information.hThread) {
				if(auto exp = collectException(enforce(CloseHandle(Information.hThread), new ProcessException(ERR.toText)))) {
					if(e) {
						e.next = exp;
					} else {
						e = exp;
					}
				}
			}
			delete Information;
			if(e) {
				throw e;;
			}
		}
	}
	///
	override const HANDLE opCall() {
		return Information.hProcess;
	}

	///
	protected PROCESSINFORMATION* Information;
	///
	ref PROCESSINFORMATION info() {
		return *Information;
	}
	///
	enum CREATE {
		NONE = 0,
		BREAKAWAY_FROM_JOB      = CREATE_BREAKAWAY_FROM_JOB  , /// Windows 2000：あるプロセスが特定のジョブに関連付けられている場合でも、その子プロセスをそのジョブに関連付けません。呼び出し側プロセスがどのジョブにも関連付けられていない場合、このフラグには意味はありません。呼び出し側が特定のオブジェクトに関連付けられている場合、そのオブジェクトは JOBOBJECT_BASIC_LIMIT_INFORMATION 構造体の LimitFlags メンバで JOB_OBJECT_LIMIT_BREAKAWAY_OK を指定しなければなりません。さもないと、CreateProcess 関数は失敗します。
		DEFAULT_ERROR_MODE      = CREATE_DEFAULT_ERROR_MODE  , /// 新しいプロセスは、呼び出し側プロセスのエラーモードを継承しません。代わりに、CreateProcess 関数は新しいプロセスに、現在の既定のエラーモードを割り当てます。アプリケーションは 関数を呼び出すことにより、現在の既定のエラーモードを設定できます。マルチスレッド化されたシェルアプリケーションが、ハードエラーを無効にして動作する場合、このフラグは特に役立ちます。CreateProcess 関数の既定の動作では、新しいプロセスは、呼び出し側のエラーモードを継承します。このフラグを指定すると、この既定の動作は無効になります。
		//FORCE_DOS               = CREATE_FORCE_DOS           , /// Windows NT/2000：このフラグは、16 ビット版のアプリケーションを起動する場合にのみ有効です。このフラグを指定すると、システムはアプリケーションを強制的に、OS/2 ベースのアプリケーションではなく MS-DOS ベースのアプリケーションとして動作させます。
		NEW_CONSOLE             = CREATE_NEW_CONSOLE         , /// 新しいプロセスは、親のコンソールを継承せず、新しいコンソールを持ちます。DETACHED_PROCESS フラグと同時に指定することはできません。
		NEW_PROCESS_GROUP       = CREATE_NEW_PROCESS_GROUP   , /// 新しいプロセスを、新しいプロセスグループのルートプロセスにします。このルートプロセスのすべての子孫プロセスは、このプロセスグループを形成します。新しいプロセスグループのプロセス識別子は、lpProcessInformation パラメータに格納されたプロセス識別子と同じ値です。 関数はプロセスグループを使って、Ctrl+C または Ctrl+Break の信号を、複数のコンソールプロセスからなるグループへ送信します。
		NO_WINDOW               = CREATE_NO_WINDOW           , /// Windows NT/2000：このフラグは、コンソールアプリケーションを起動する場合にのみ有効です。このフラグを指定すると、コンソールウィンドウなしでアプリケーションを実行します。
		SEPARATE_WOW_VDM        = CREATE_SEPARATE_WOW_VDM    , /// Windows NT/2000：このフラグは、16 ビット版 Windows ベースのアプリケーションを起動する場合にのみ有効です。このフラグを指定すると、新しいプロセスはプライベート VDM（仮想 DOS マシン）内で動作します。既定では、16 ビット版 Windows ベースのすべてのアプリケーションが 1 つの共有 VDM 内で動作します。これらのアプリケーションを個別に動作させると、どれか 1 つのアプリケーションがクラッシュした場合でも、1 つの VDM が終了するだけで済むという利点があります。他の VDM 内で動作している他のすべてのプログラムは、正常に動作を続けます。また、16 ビット版 Windows ベースのアプリケーションを個別の VDM 内で動作させると、個別の入力キューを割り当てることができます。これは、1 つのアプリケーションが瞬間的に応答を停止した場合でも、他の VDM 内で動作しているアプリケーションは引き続き入力を受け取れることを意味します。逆に、各アプリケーションを個別の VDM 内で動作させると、多くのメモリを余分に消費するという欠点があります。16 ビット版アプリケーションを個別の VDM で動作させるようユーザーが要求した場合にのみ、このフラグを使うべきです。
		SHARED_WOW_VDM          = CREATE_SHARED_WOW_VDM      , /// Windows NT/2000：このフラグは、16 ビット版 Windows ベースのアプリケーションを起動する場合にのみ有効です。WIN.INI ファイルの [Windows] セクションの DefaultSeparateVDM スイッチが TRUE に設定されている場合、このフラグを指定すると、CreateProcess 関数はそのスイッチを無効にし、新しいプロセスを共有 VDM 内で動作させます。
		SUSPENDED               = CREATE_SUSPENDED           , /// プライマリスレッドをサスペンド状態にして、新しいプロセスを作成します。ResumeThread 関数を呼び出すまで、そのスレッドを開始させません。
		UNICODE_ENVIRONMENT     = CREATE_UNICODE_ENVIRONMENT , /// lpEnvironment パラメータが指す環境ブロックの形式を指定します。このフラグを指定すると、その環境ブロックは Unicode 文字を使います。このフラグを指定しなかった場合、ANSI 文字を使います。
		DEBUG_PROCESS           =  DEBUG_PROCESS              , /// このフラグを指定すると、呼び出し側プロセスをデバッガ、新しいプロセスをデバッグ対象として扱います。システムは、デバッグ対象のプロセス内で発生するすべてのデバッグイベントを呼び出し側スレッドへ通知します。このフラグを指定してプロセスを作成すると、呼び出し側スレッド（CreateProcess 関数を呼び出したスレッド）だけが 関数を呼び出せます。Windows 95/98：新しいプロセスが 16 ビット版アプリケーションの場合、このフラグは有効ではありません。
		DEBUG_ONLY_THIS_PROCESS =  DEBUG_ONLY_THIS_PROCESS    , /// 呼び出し側プロセスがデバッグ対象であるときに、このフラグを指定せずに CreateProcess 関数を呼び出すと、呼び出し側プロセスを扱っているデバッガは、新しいプロセスもデバッグ対象とします。呼び出し側プロセスがデバッグ対象ではない場合、デバッグ関連の動作は発生しません。
		DETACHED_PROCESS        =  DETACHED_PROCESS           , /// コンソールプロセスを対象としたフラグであり、新しいプロセスに、親プロセスのコンソールへのアクセスを許可しません。新しいプロセスは、 関数を使って新しいコンソールを作成できます。CREATE_NEW_CONSOLE フラグと同時に指定することはできません。
	}

	///
	enum PRIORITY {
		NONE = 0,
		NORMAL       = NORMAL_PRIORITY_CLASS       , /// 通常クラス。特別なスケジューリングを必要としない、一般的なプロセスであることを指定します。
		IDLE         = IDLE_PRIORITY_CLASS         , /// アイドルクラス。システムがアイドル状態のときにだけスレッドを実行するプロセスであることを指定します。アイドルクラスの優先権は子プロセスに引き継がれます。
		HIGH         = HIGH_PRIORITY_CLASS         , /// 優先クラス。すぐに実行されなければならないタイムクリティカルなタスクを実行するプロセスであることを指定します。この優先度クラスのプロセスに属するスレッドは、通常クラスやアイドルクラスのプロセスに属するスレッドのより優先して実行されます。このクラスのアプリケーションはほぼすべての CPU 空き時間を占有可能となるため、このクラスを設定する場合は十分に注意する必要があります。
		REALTIME     = REALTIME_PRIORITY_CLASS     , /// リアルタイムクラス。最も高い優先順位クラスを持つプロセスであることを指定します。この優先度クラスのプロセスに属するスレッドは、他のすべてのプロセス（システムの重要なタスクを実行するOS のプロセスも含む）に属するスレッドのより優先して実行されます。
		BELOW_NORMAL = BELOW_NORMAL_PRIORITY_CLASS , /// Windows 2000/XP： IDLE_PRIORITY_CLASS 以上で NORMAL_PRIORITY_CLASS 以下の優先度を持つことを示します。
		ABOVE_NORMAL = ABOVE_NORMAL_PRIORITY_CLASS , /// Windows 2000/XP： NORMAL_PRIORITY_CLASS 以上で HIGH_PRIORITY_CLASS 以下の優先度を持つことを示します。
	}

	/***/
	override this(HANDLE Handle, bool Suicide) {
		super(Handle, Suicide);
	}
	///
	this(HANDLE hProcess, HANDLE hThread, bool Suicide) {
		this(hProcess, false);

		Information = new PROCESSINFORMATION;
		Information.hProcess = hProcess;
		Information.hThread  = hThread;
	}

	///
	this(
		in Text ApplicationName, in Text CommandLine, in Text WorkFolder,
		const SECURITY* ProcessSecurity, const SECURITY* ThreadSecurity,
		bool Inheritance,
		PRIORITY Priority, CREATE Create,
		const TEXTNULLLIST* TextNullList,
		const ref STARTUPINFORMATION StartupInformation
	) {
		Information = new PROCESSINFORMATION;

		enforce(
			CreateProcess(
				ApplicationName.ptr(true),
				CommandLine.ptr(true),
				ProcessSecurity ? ProcessSecurity.ptr: null,
				ThreadSecurity ? ThreadSecurity.ptr: null,
				Inheritance,
				Priority | Create,
				TextNullList ? TextNullList.ptr: null,
				WorkFolder.ptr(true),
				StartupInformation.ptr,
				Information.ptr
			),
			new ProcessException(ERR.toText)
		);

		this(Information.hProcess, true);

	}

	///
	this(
		in Text ApplicationName, in Text CommandLine, in Text WorkFolder,
		const ref SECURITY ProcessSecurity, const ref SECURITY ThreadSecurity,
		bool Inheritance,
		PRIORITY Priority, CREATE Create,
		const ref TEXTNULLLIST TextNullList,
		const ref STARTUPINFORMATION StartUpInfomation
	) {
		this(
			ApplicationName, CommandLine, WorkFolder,
			&ProcessSecurity, &ThreadSecurity,
			Inheritance,
			Priority, Create,
			&TextNullList,
			StartUpInfomation
		);
	}
	///
	this(in Text ApplicationName, in Text CommandLine, in Text WorkFolder, const ref STARTUPINFORMATION StartUpInfomation) {
		this(
			ApplicationName, CommandLine, WorkFolder,
			null, null,
			true,
			PRIORITY.NONE, CREATE.NONE,
			null,
			StartUpInfomation
		);
	}


	///
	@property const DWORD exitCode() {
		DWORD ExitCode;
		enforce(GetExitCodeProcess(Information.hProcess, &ExitCode), new ProcessException(ERR.toText));
		return ExitCode;
	}

	///
	@property const PRIORITY priority() {
		if(auto Priority=GetPriorityClass(Information.hProcess)) {
			return cast(PRIORITY)Priority;
		} else {
			throw new ProcessException(ERR.toText);
		}
	}
	///
	@property bool priority(PRIORITY Priority) {
		return cast(bool)SetPriorityClass(Information.hProcess, Priority);
	}
}

///
class ExecuteException: ProcessException {
	mixin MixInNeGuiException;
}

/***/
struct EXECUTEINFORMATION {
	SHELLEXECUTEINFO ShellExecuteInfo;
	mixin(SMixInStructHiddenOriginal!(SHELLEXECUTEINFO)(q{ShellExecuteInfo}));

	/***/
	void initialize() {
		ShellExecuteInfo.cbSize = ShellExecuteInfo.sizeof;
	}

	///
	enum MASK {
		CLASSKEY       = SEE_MASK_CLASSKEY       , /// hKeyClassで与えるクラスキーを使用する
		CLASSNAME      = SEE_MASK_CLASSNAME      , /// lpClassで与えるクラス名を使用する
		CONNECTMETDRV  = SEE_MASK_CONNECTNETDRV  , /// ドライブと接続する(lpFileはネットワーク上のUNCパス名と接続する)
		DOENVSUBST     = SEE_MASK_DOENVSUBST     , /// lpDirectory or lpFileで与えられる文字列内の環境変数を展開する
		FLAG_DDEWAIT   = SEE_MASK_FLAG_DDEWAIT   , /// 関数から戻る前終了するため、DDE接続を待つ
		FLAG_NO_UI     = SEE_MASK_FLAG_NO_UI     , /// エラー発生時にはエラーメッセージボックスを表示しない
		HOTKEY         = SEE_MASK_HOTKEY         , /// dwHotKeyで与えられるホットキーを使用する
		ICON           = SEE_MASK_ICON           , /// hIconで与えられるアイコンを使用する
		IDLIST         = SEE_MASK_IDLIST         , /// lpIDListで与えられるITEMIDリストを使用する
		INVOKEIDLIST   = SEE_MASK_INVOKEIDLIST   , /// アプリケーションを起動するためlpIDListで与えられるITEMIDリストを使用する(lpIDListが0のとき新しいITEMIDリストを作成する)
		NOCLOSEPROCESS = SEE_MASK_NOCLOSEPROCESS , /// ShellExecuteEx()関数終了後、プロセスの実行を継続する
	}
	mixin(SMixInClassGetSet!(MASK)("mask", q{ShellExecuteInfo.fMask}, false));

	///
	@property const NeGui owner() {
		return NeGui.getGuiObject(ShellExecuteInfo.hwnd);
	}
	///
	@property void owner(in NeGui Owner) {
		ShellExecuteInfo.hwnd = Owner ? Owner(): null;
	}

	///
	enum OPERATION {
		EDIT,       /// エディタを起動し、編集のためにドキュメントを開きます。 lpFile メンバがドキュメントファイルでない場合は、関数は失敗します。
		OPEN,       /// lpFile メンバで指定された実行可能ファイル、ドキュメントファイル、フォルダを開きます。
		PRINT,      /// lpFile メンバで指定されたドキュメントファイルを印刷します。 lpFile メンバがドキュメントファイルでない場合は、関数は失敗します。
		EXPLORER,   /// pFile メンバで指定されたフォルダをエクスプローラで開きます。
		PROPERTIES, /// ファイルまたはフォルダのプロパティを表示します。
		FIND,       /// 指定されたディレクトリから開始される検索を実行します。
		DEFAULT,    /// NULL
	}
	static pure const(Text) operationToText(OPERATION Operation) {
		final switch(Operation) {
			case OPERATION.EDIT:       return Text.iwrap("edit"w);
			case OPERATION.OPEN:       return Text.iwrap("open"w);
			case OPERATION.PRINT:      return Text.iwrap("print"w);
			case OPERATION.EXPLORER:   return Text.iwrap("explorer"w);
			case OPERATION.PROPERTIES: return Text.iwrap("properties"w);
			case OPERATION.FIND:       return Text.iwrap("find"w);
			case OPERATION.DEFAULT:    return Text.init;
		}
	}
	/+
	@property const Text operation() {
		return Text(ShellExecuteInfo.lpVerb);
	}
	@property void operation(in Text Operation) {
		if(Operation.length) {
			ShellExecuteInfo.lpVerb = Operation.ptr;
		} else {
			ShellExecuteInfo.lpVerb = null;
		}
	}
	+/
	mixin(SMixInStructGetSet!(Text, true)("operation", q{ShellExecuteInfo.lpVerb}));
	///
	@property void operation(OPERATION Operation) {
		operation = operationToText(Operation);
	}

	/+
	const Text file() {
		return Text(ShellExecuteInfo.lpFile);
	}
	void file(in Text File) {
		ShellExecuteInfo.lpFile = File.ptr;
	}
	+/
	mixin(SMixInStructGetSet!(Text, true)("file", q{ShellExecuteInfo.lpFile}));

	mixin(SMixInStructGetSet!(Text, true)("parameters", q{ShellExecuteInfo.lpParameters}));
	/+
	const Text parameters() {
		return Text(ShellExecuteInfo.lpParameters);
	}
	void parameters(in Text Parameters) {
		if(Parameters.length) {
			ShellExecuteInfo.lpParameters = Parameters.ptr;
		} else {
			ShellExecuteInfo.lpParameters = null;
		}
	}
	+/

	mixin(SMixInStructGetSet!(Text, true)("workFolder", q{ShellExecuteInfo.lpDirectory}));
	mixin(SMixInStructGetSet!(SHOW)("show", q{ShellExecuteInfo.nShow}));

	mixin(SMixInStructGetSet!(HINSTANCE)("instance", q{ShellExecuteInfo.hInstApp}));
	///
	enum ERROR {
		FNF              = SE_ERR_FNF             , /// ファイルが見つかりません。
		PNF              = SE_ERR_PNF             , /// パスが見つかりません。
		ACCESSDENIED     = SE_ERR_ACCESSDENIED    , /// ファイルアクセスが拒否されました。
		OOM              = SE_ERR_OOM             , /// メモリ不足です。
		SHARE            = SE_ERR_SHARE           , /// 共有違反が発生しました。
		ASSOCINCOMPLETE  = SE_ERR_ASSOCINCOMPLETE , /// ファイル関連付けが完全ではないか無効です。
		DDETIMEOUT       = SE_ERR_DDETIMEOUT      , /// DDE トランザクションがタイムアウトにより中断されました。
		DDEFAIL          = SE_ERR_DDEFAIL         , /// DDE トランザクションが失敗しました。
		DDEBUSY          = SE_ERR_DDEBUSY         , /// 他の DDE トランザクションが処理されていたため DDE トランザクションが終了できませんでした。
		NOASSOC          = SE_ERR_NOASSOC         , /// ファイル関連付けが不明です。
		DLLNOTFOUND      = SE_ERR_DLLNOTFOUND     , /// DLL が見つかりません。
	}
	///
	static bool isError(HINSTANCE Instance) {
		return ERROR.max >= cast(size_t)Instance;
	}

	mixin(SMixInStructGetSet!(ITEMIDLIST*)("itemID", q{ShellExecuteInfo.lpIDList}));

	mixin(SMixInStructGetSet!(Text, true)("className", q{ShellExecuteInfo.lpClass}));
	mixin(SMixInStructGetSet!(HKEY)("classKey", q{ShellExecuteInfo.hkeyClass}));

	///
	@property const ref HOTKEYVALUE hotkey() {
		auto HotKeyValue=new HOTKEYVALUE;

		HotKeyValue.Key = cast(KEY)LOWORD(ShellExecuteInfo.dwHotKey);
		HotKeyValue.Mod = cast(HOTKEY)HIWORD(ShellExecuteInfo.dwHotKey);

		return *HotKeyValue;
	}
	///
	@property void hotkey(const ref HOTKEYVALUE HotKeyValue) {
		ShellExecuteInfo.dwHotKey = MAKELONG(HotKeyValue.key, HotKeyValue.ext);
	}

	///
	@property const Icon icon() {
		return ShellExecuteInfo.hIcon
			? new Icon(ShellExecuteInfo.hIcon, false)
			: null
		;
	}
	///
	@property void icon(in Icon icon) {
		ShellExecuteInfo.hIcon = icon ? icon(): null;
	}

	///
	@property const Monitor monitor() {
		return ShellExecuteInfo.hIcon
			? new Monitor(ShellExecuteInfo.hIcon)
			: null
		;
	}
	///
	@property void monitor(in Monitor monitor) {
		ShellExecuteInfo.hIcon = monitor ? monitor(): null;
	}

	//mixin(SMixInStructGetSet!(HANDLE)("process", q{ShellExecuteInfo.hProcess}));
	///
	@property const Process process() {
		return ShellExecuteInfo.hProcess
			? new Process(ShellExecuteInfo.hProcess, null, false)
			: null
		;
	}
	///
	@property void process(in Process process) {
		ShellExecuteInfo.hProcess = process ? process(): null;
	}

	/**
	設定値の実行

	Throws:
		実行に失敗した場合はExecuteException。
	*/
	HINSTANCE run() {
		ERR.init;
		auto hInstance=ShellExecuteEx(&ShellExecuteInfo);
		immutable Code=ERR.code;
		enforce(!isError(cast(HANDLE)hInstance), new ExecuteException(ERR.toText(Code)));

		return cast(HINSTANCE)hInstance;
	}

}

