﻿/**
NeGuiの例外クラス。

NeGuiはException投げてもErrorは投げない。
※あくまで明示的にだけど。

History:
	1.00β19:
		新規作成。
*/
module etc.negui.system.exception;

debug import std.stdio: wl = writefln;
debug(exception) void main() {}

import std.contracts;
//import std.date;
import std.string;

import etc.negui.system.utility.array; // Error: struct etc.negui.system.text.Text no size yet for forward reference
import etc.negui.system.text;
import etc.negui.system.time;

/**
History:
	1.032:
		[F] NeGui自体にエラーコードいらねーや。
*/
class NeGuiException: Exception, IText {
	private {
		//d_time  Time;
		DateTime Time;
	}
	this(in Text msg, Throwable next=null, string _file=__FILE__, int _line=__LINE__) {
		super(msg.text8, _file, _line, next);
		//Time = UTCtoLocalTime(getUTCtime());
		Time = new DateTime;//UTCtoLocalTime(getUTCtime());
	}
	/**
	*/
	final const const(DateTime) time() {
		return Time;
	}

	/**
	Note:
		Throwable.toStringと組み合わせて使用するためconstでない。

	History:
		1.032:
			新規作成。
	*/
	protected string ExceptionMessage() {
		return format(
			"%s@%s(%s): %s [%s]",
			this.classinfo.name,
			file,
			line,
			msg,
			time
		);
	}
	/// 未実装。
	override const Text toText() {
		return Text.init;
	}
	
	/**
	History:
		1.032:
			[P] 処理内容変更。
	*/
	override string toString() {
		auto s=ExceptionMessage();
		
		if(next) {
			s ~= newline ~ next.toString;
		}

		return s;
	}

}
/***/
mixin template MixInNeGuiException() {
	override this(in Text msg, Throwable next=null, string file=__FILE__, int line=__LINE__) {
		super(msg, next, file, line);
	}
}
/***/
void ThrowableChain(ref Throwable e, Throwable NewThrowable)
in {
	assert(NewThrowable);
}
out {
	assert(e);
}
body {
	if(e) {
		e.next = NewThrowable;
		e = e.next;
	} else {
		e = NewThrowable;
	}
}

/***/
struct THROWABLECHAIN {
	private Throwable base, next;
	/**
	*/
	static nothrow THROWABLECHAIN opCall(Throwable Base) {
		THROWABLECHAIN tc;

		tc.next = tc.base = Base;

		return tc;
	}
	/**
	*/
	void chain(Throwable Next) {
		ThrowableChain(next, Next);
	}
	/**
	*/
	T collect(T, string _file=__FILE__, int _line=__LINE__)(T expression, out bool IsNoThrow) {
		T Result;
		if(auto e=collectException(expression, Result)) {
			e.file = _file;
			e.line = _line;
			chain(e);
			IsNoThrow = true;
		} else {
			IsNoThrow = false;
		}
		
		return Result;
	}
	/**
	*/
	Throwable opCall() {
		if(base.next) {
			return base;
		} else {
			return null;
		}
	}
}


