﻿/**

*/
module etc.negui.system.meta.memberproperty;

debug import std.stdio: wl = writefln;
debug(memberproperty) void main() {}

import etc.negui.system.text;

/**
History:
	1.100:
		[S] Text対応。
		[S] @property追加。
*/
pure nothrow string SMixInMemberGet(T, bool TEXTCONV=false)(in string Method, in string Member, bool Override)
in {
	assert(Method.length);
	assert(Member.length);
}
body {
	string ReturnStatement;
	static if(is(T == Text)) {
		static if(TEXTCONV) {
			ReturnStatement = `return Text(` ~ Member ~ `);`;
		} else {
			ReturnStatement = `return cast(` ~ (T).stringof ~ `)` ~ Member ~ `;`;
		}
		/+
		ReturnStatement = `
			static if(is(typeof(` ~ Member ~ `) == wchar*)) {
				return Text(` ~ Member ~ `);
			} else {
				return ` ~ Member ~ `;
			}
		`;
		+/
	} else {
		ReturnStatement = `return cast(` ~ (T).stringof ~ `)` ~ Member ~ `;`;
	}
	string Property;
	static if(is(T == function)||is(T == delegate)||is(T == return)) {
		Property = null;
	} else {
		Property = q{@property};
	}
	
	return `

	` ~ Property ~ ` ` ~ (Override ? "override": "") ~ ` const  ` ~ (T).stringof ~ ` ` ~ Method ~ `() {
		` ~ ReturnStatement ~ `;
	}

	`;
}
/**
History:
	1.100:
		[S] Text対応。
		[S] @property追加。
		[P] 戻り値。
*/
pure nothrow string SMixInMemberSet(T, bool TEXTCONV=false)(in string Method, in string Member, bool Override)
in {
	assert(Method.length);
	assert(Member.length);
}
body {
	invariant Arg = Method ~ "Arg";
	string AssignStatement;
	string RetType;
	static if(is(T == Text)) {
		static if(TEXTCONV) {
			AssignStatement = Member ~ ` = ` ~ Arg ~ `.ptr;`;
		} else {
			AssignStatement = Member ~ ` = ` ~ Arg ~ `.dup;`;
		}
		RetType = "void";
		/+
		AssignStatement = `
			static if(is(typeof(` ~ Member ~ `) == wchar*)) {
				` ~ Member ~ ` = ` ~ Arg ~ `.ptr;
			} else {
				` ~ Member ~ ` = ` ~ Arg ~ `;
			}
		`;
		+/
	} else {
		RetType = T.stringof;
		AssignStatement = `return cast(` ~ RetType ~ `)(` ~ Member ~ ` = cast(typeof(` ~ Member ~ `))` ~ Arg ~ `)`;
	}
	
	string Property;
	static if(is(T == function)||is(T == delegate)||is(T == return)) {
		Property = null;
	} else {
		Property = q{@property};
	}
	
	return `

	` ~ Property ~ ` ` ~ (Override ? "override": "") ~ ` ` ~ RetType ~ ` ` ~ Method~ `(in ` ~ (T).stringof ~ ` ` ~ Arg ~ `) {
		` ~ AssignStatement ~ `;
	}

	`;
}

debug(memberproperty) unittest {
	wl(SMixInClassGetSet!int("aaa", "struct.memberproperty",true));
	wl(SMixInClassGetSet!Text("bbb", "struct.memberproperty",true));
	wl(SMixInClassGetSet!(Text,false)("bbb", "struct.memberproperty",true));
}

pure nothrow string SMixInClassGet(T, bool TEXTCONV=false)(in string Method, in string Member, bool Override) {
	return SMixInMemberGet!(T, TEXTCONV)(Method, Member, Override);
}
pure nothrow string SMixInClassSet(T, bool TEXTCONV=false)(in string Method, in string Member, bool Override) {
	return SMixInMemberSet!(T, TEXTCONV)(Method, Member, Override);
}
pure nothrow string SMixInStructGet(T, bool TEXTCONV=false)(in string Method, in string Member) {
	return SMixInMemberGet!(T, TEXTCONV)(Method, Member, false);
}
pure nothrow string SMixInStructSet(T, bool TEXTCONV=false)(in string Method, in string Member) {
	return SMixInMemberSet!(T, TEXTCONV)(Method, Member, false);
}

pure nothrow string SMixInClassGetSet(T, bool TEXTCONV=false)(in string Method, in string Member, bool Override) {
	return
	SMixInMemberGet!(T, TEXTCONV)(Method, Member, Override)
	~
	SMixInMemberSet!(T, TEXTCONV)(Method, Member, Override)
	;
}

///
pure nothrow string SMixInStructGetSet(T, bool TEXTCONV=false)(in string Method, in string Member) {
	return SMixInClassGetSet!(T, TEXTCONV)(Method, Member, false);
}

/**
History:
	1.061:
		[S] あまりにもvoid*がキモかったんで修正。

	1.00β15:
		[S] なんとなーくTをポインタの型じゃなくて元の型に変更。void*が微妙な記述になった。
*/
pure nothrow string SMixInStructHiddenOriginal(T)(in string Member)
in {
	assert(Member.length);
}
body {
	string TYPE;
	if(is(T == void*)) {
		TYPE = void.stringof;
	} else {
		TYPE = T.stringof;
	}
	
	return `
	const ` ~ TYPE ~ `* ptr() {
		return cast(` ~ TYPE ~ `*)&` ~ Member ~ `;
	}

	const ` ~ TYPE ~ `* opDot() {
		return cast(` ~ TYPE ~ `*)&` ~ Member ~ `;
	}
	
	`;
}

